//+------------------------------------------------------------------+
//|                                               Golovnaya_Boll.mq4 |
//|                                                          Russian |
//|                                                          Russian |
//+------------------------------------------------------------------+
#property copyright "Russian"
#property link      "Russian"
#property indicator_chart_window

extern int period=PERIOD_H4;
extern int period_M30=PERIOD_M30;
extern int period_H1=PERIOD_H1;
extern int line.width_trend=1;
extern int line.width=2;
extern color  LR.c=Orange;
extern color  LR.c_M30=PaleGoldenrod;
extern color  LR.c_H1=LightCoral;
extern double std.channel.1=1.618;        // 1st channel
extern color  c.1=Green;
extern color  c.1_M30=Goldenrod;
extern color  c.1_H1=DarkTurquoise;
extern double std.channel.2=2.618;        // 2nd channel
extern color  c.2=Red;
extern color  c.2_M30=Indigo;
extern color  c.2_H1=Yellow;
int LR.length = 144;
int  LR.length_M30 = 200;
int  LR.length_H1 = 180;

int init(){return(0);}

int deinit()
{ 
   ObjectDelete(period+"m "+LR.length+" TL"); 
   ObjectDelete(period+"m "+LR.length+" +"+std.channel.1+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.1+"d");
   ObjectDelete(period+"m "+LR.length+" +"+std.channel.2+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.2+"d");
   ObjectDelete("MaxText"); 
Comment("");
ObjectDelete("Line_Max");
ObjectDelete("Line_Min");
ObjectDelete("MA");
ObjectDelete("MaximymSD");
   ObjectDelete(period_M30+"m "+LR.length_M30+" TL"); 
   ObjectDelete(period_M30+"m "+LR.length_M30+" +"+std.channel.1+"d"); ObjectDelete(period_M30+"m "+LR.length_M30+" -"+std.channel.1+"d");
   ObjectDelete(period_M30+"m "+LR.length_M30+" +"+std.channel.2+"d"); ObjectDelete(period_M30+"m "+LR.length_M30+" -"+std.channel.2+"d");
   ObjectDelete("MaxText"); 
Comment("");
ObjectDelete("Line_Max");
ObjectDelete("Line_Min");
ObjectDelete("MA");
ObjectDelete("MaximymSD");
   ObjectDelete(period_H1+"m "+LR.length_H1+" TL"); 
   ObjectDelete(period_H1+"m "+LR.length_H1+" +"+std.channel.1+"d"); ObjectDelete(period_H1+"m "+LR.length_H1+" -"+std.channel.1+"d");
   ObjectDelete(period_H1+"m "+LR.length_H1+" +"+std.channel.2+"d"); ObjectDelete(period_H1+"m "+LR.length_H1+" -"+std.channel.2+"d");
   ObjectDelete("MaxText"); 
Comment("");
ObjectDelete("Line_Max");
ObjectDelete("Line_Min");
ObjectDelete("MA");
ObjectDelete("MaximymSD");
}

int start(){//refresh chart


if(LR.length>Bars) {
  Comment("\n\n                    ERROR - TOO SMALL HISTORY, RETURN NOW!");
  
  return(-1); // then exit
}
  
//--End of Min&Max--
ObjectDelete(period+"m "+LR.length+" TL");
ObjectDelete(period+"m "+LR.length+" +"+std.channel.1+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.1+"d");
ObjectDelete(period+"m "+LR.length+" +"+std.channel.2+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.2+"d");
//------
ObjectDelete(period_M30+"m "+LR.length_M30+" TL");
ObjectDelete(period_M30+"m "+LR.length_M30+" +"+std.channel.1+"d"); ObjectDelete(period_M30+"m "+LR.length_M30+" -"+std.channel.1+"d");
ObjectDelete(period_M30+"m "+LR.length_M30+" +"+std.channel.2+"d"); ObjectDelete(period_M30+"m "+LR.length_M30+" -"+std.channel.2+"d");
//------
ObjectDelete(period_H1+"m "+LR.length_H1+" TL");
ObjectDelete(period_H1+"m "+LR.length_H1+" +"+std.channel.1+"d"); ObjectDelete(period_H1+"m "+LR.length_H1+" -"+std.channel.1+"d");
ObjectDelete(period_H1+"m "+LR.length_H1+" +"+std.channel.2+"d"); ObjectDelete(period_H1+"m "+LR.length_H1+" -"+std.channel.2+"d");
//linear regression calculation

   //H4
   int start.bar=LR.length, end.bar=0;
   int n=start.bar-end.bar+1;

   //M30
   int start.bar_M30=LR.length_M30, end.bar_M30=0;
   int n_M30=start.bar_M30-end.bar_M30+1;

   //H1
   int start.bar_H1=LR.length_H1, end.bar_H1=0;
   int n_H1=start.bar_H1-end.bar_H1+1;

//---- calculate price values H4
   double value=iClose(Symbol(),period,end.bar);
   double a,b,c;
   double sumy=value;
   double sumx=0.0;
   double sumxy=0.0;
   double sumx2=0.0;
//---- calculate price values M30
   double value_M30=iClose(Symbol(),period_M30,end.bar_M30);
   double a_M30,b_M30,c_M30;
   double sumy_M30=value_M30;
   double sumx_M30=0.0;
   double sumxy_M30=0.0;
   double sumx2_M30=0.0;
//---- calculate price values H1
   double value_H1=iClose(Symbol(),period_H1,end.bar_H1);
   double a_H1,b_H1,c_H1;
   double sumy_H1=value_H1;
   double sumx_H1=0.0;
   double sumxy_H1=0.0;
   double sumx2_H1=0.0;
   
     for(int i=1; i<n; i++)
     {     //H4
      value=iClose(Symbol(),period,end.bar+i);
      sumy+=value;
      sumxy+=value*i;
      sumx+=i;
      sumx2+=i*i;
      }
      for(int i_M30=1; i_M30<n_M30; i_M30++)
     {     //M30
      value_M30=iClose(Symbol(),period_M30,end.bar_M30+i_M30);
      sumy_M30+=value_M30;
      sumxy_M30+=value_M30*i_M30;
      sumx_M30+=i_M30;
      sumx2_M30+=i_M30*i_M30;
      }
      for(int i_H1=1; i_H1<n_H1; i_H1++)
     {      //H1
      value_H1=iClose(Symbol(),period_H1,end.bar_H1+i_H1);
      sumy_H1+=value_H1;
      sumxy_H1+=value_H1*i_H1;
      sumx_H1+=i_H1;
      sumx2_H1+=i_H1*i_H1;
     }
     //H4
   c=sumx2*n-sumx*sumx;
   if(c==0.0) return;
   b=(sumxy*n-sumx*sumy)/c;
   a=(sumy-sumx*b)/n;
   double LR.price.2=a;
   double LR.price.1=a+b*n;
      //M30
   c_M30=sumx2_M30*n_M30-sumx_M30*sumx_M30;
   if(c_M30==0.0) return;
   b_M30=(sumxy_M30*n_M30-sumx_M30*sumy_M30)/c_M30;
   a_M30=(sumy_M30-sumx_M30*b_M30)/n_M30;
   double LR.price.2_M30=a_M30;
   double LR.price.1_M30=a_M30+b_M30*n_M30;
     //H1
   c_H1=sumx2_H1*n_H1-sumx_H1*sumx_H1;
   if(c_H1==0.0) return;
   b_H1=(sumxy_H1*n_H1-sumx_H1*sumy_H1)/c_H1;
   a_H1=(sumy_H1-sumx_H1*b_H1)/n_H1;
   double LR.price.2_H1=a_H1;
   double LR.price.1_H1=a_H1+b_H1*n_H1;

//---- maximal deviation calculation (not used)
        //H1
   double max.dev=0;
   double deviation=0;
   double dvalue=a;
        //M30
   double max.dev_M30=0;
   double deviation_M30=0;
   double dvalue_M30=a_M30;
        //H1
   double max.dev_H1=0;
   double deviation_H1=0;
   double dvalue_H1=a_H1;
   for(i=0; i<n; i++)
     {
      //H4
      value=iClose(Symbol(),period,end.bar+i);
      dvalue+=b;
      deviation=MathAbs(value-dvalue);
      if(max.dev<=deviation) max.dev=deviation;
      }
   for(i_M30=0; i_M30<n_M30; i_M30++)
     {
      //M30
      value_M30=iClose(Symbol(),period_M30,end.bar_M30+i_M30);
      dvalue_M30+=b_M30;
      deviation_M30=MathAbs(value_M30-dvalue_M30);
      if(max.dev_M30<=deviation_M30) max.dev_M30=deviation_M30;
      }
   for(i_H1=0; i_H1<n_H1; i_H1++)
     {
      //H1
      value_H1=iClose(Symbol(),period_H1,end.bar_H1+i_H1);
      dvalue_H1+=b_H1;
      deviation_H1=MathAbs(value_H1-dvalue_H1);
      if(max.dev_H1<=deviation_H1) max.dev_H1=deviation_H1;
     }
//Linear regression trendline H4
   ObjectCreate(period+"m "+LR.length+" TL",OBJ_TREND,0,iTime(Symbol(),period+0,start.bar),LR.price.1,Time[end.bar],LR.price.2);
   ObjectSet(period+"m "+LR.length+" TL",OBJPROP_COLOR,LR.c);
   ObjectSet(period+"m "+LR.length+" TL",OBJPROP_WIDTH,line.width_trend);
   ObjectSet(period+"m "+LR.length+" TL",OBJPROP_RAY,false); 
   SetIndexLabel(0,"1-st Level Stop/Reverse"); 
//Linear regression trendline M30
   ObjectCreate(period_M30+"m "+LR.length_M30+" TL",OBJ_TREND,0,iTime(Symbol(),period_M30,start.bar_M30),LR.price.1_M30,Time[end.bar_M30],LR.price.2_M30);
   ObjectSet(period_M30+"m "+LR.length_M30+" TL",OBJPROP_COLOR,LR.c_M30);
   ObjectSet(period_M30+"m "+LR.length_M30+" TL",OBJPROP_WIDTH,line.width_trend);
   ObjectSet(period_M30+"m "+LR.length_M30+" TL",OBJPROP_RAY,false); 
   SetIndexLabel(0,"1-st Level Stop/Reverse"); 
//Linear regression trendline H1
   ObjectCreate(period_H1+"m "+LR.length_H1+" TL",OBJ_TREND,0,iTime(Symbol(),period_H1,start.bar_H1),LR.price.1_H1,Time[end.bar_H1],LR.price.2_H1);
   ObjectSet(period_H1+"m "+LR.length_H1+" TL",OBJPROP_COLOR,LR.c_H1);
   ObjectSet(period_H1+"m "+LR.length_H1+" TL",OBJPROP_WIDTH,line.width_trend);
   ObjectSet(period_H1+"m "+LR.length_H1+" TL",OBJPROP_RAY,false); 
   SetIndexLabel(0,"1-st Level Stop/Reverse");    
//...standard deviation H4
   double x=0,x.sum=0,x.avg=0,x.sum.squared=0,std.dev=0,std1.dev=0;
   for(i=0; i<start.bar; i++)    {
      x=MathAbs(iClose(Symbol(),period,i)-ObjectGetValueByShift(period+"m "+LR.length+" TL",i));
      x.sum+=x;
      
      if(i>0)  {
         x.avg=(x.avg+x)/i;
         x.sum.squared+=(x-x.avg)*(x-x.avg);
         std.dev=MathSqrt(x.sum.squared/(start.bar-1));
                 
  }  }
  
   ObjectCreate(period+"m "+LR.length+" +"+std.channel.2+"d",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1+std.dev*std.channel.2,
                                             Time[end.bar],LR.price.2+std.dev*std.channel.2);
   ObjectSet(period+"m "+LR.length+" +"+std.channel.2+"d",OBJPROP_COLOR,c.1);
   ObjectSet(period+"m "+LR.length+" +"+std.channel.2+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(period+"m "+LR.length+" +"+std.channel.2+"d",OBJPROP_RAY,false);
 
   ObjectCreate(period+"m "+LR.length+" -"+std.channel.2+"d",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1-std.dev*std.channel.2,
                                             Time[end.bar],LR.price.2-std.dev*std.channel.2);
   ObjectSet(period+"m "+LR.length+" -"+std.channel.2+"d",OBJPROP_COLOR,c.1);
   ObjectSet(period+"m "+LR.length+" -"+std.channel.2+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(period+"m "+LR.length+" -"+std.channel.2+"d",OBJPROP_RAY,false);

//...standard deviation M30

  double x_M30=0,x.sum_M30=0,x.avg_M30=0,x.sum.squared_M30=0,std.dev_M30=0,std1.dev_M30=0;
  for(i_M30=0; i_M30<start.bar_M30; i_M30++)    {
      x_M30=MathAbs(iClose(Symbol(),period_M30,i_M30)-ObjectGetValueByShift(period_M30+"m "+LR.length_M30+" TL",i_M30));
      x.sum_M30+=x_M30;
      if(i_M30>0)  {
         x.avg_M30=(x.avg_M30+x_M30)/i_M30;
         x.sum.squared_M30+=(x_M30-x.avg_M30)*(x_M30-x.avg_M30);
         std.dev_M30=MathSqrt(x.sum.squared_M30/(start.bar_M30-1));

  }  }
  
   
   ObjectCreate(period_M30+"m "+LR.length_M30+" +"+std.channel.2+"d",OBJ_TREND,0,iTime(Symbol(),period_M30,start.bar_M30),LR.price.1_M30+std.dev_M30*std.channel.2,
                                             Time[end.bar_M30],LR.price.2_M30+std.dev_M30*std.channel.2);
   ObjectSet(period_M30+"m "+LR.length_M30+" +"+std.channel.2+"d",OBJPROP_COLOR,c.2_M30);
   ObjectSet(period_M30+"m "+LR.length_M30+" +"+std.channel.2+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(period_M30+"m "+LR.length_M30+" +"+std.channel.2+"d",OBJPROP_RAY,false);
 
   ObjectCreate(period_M30+"m "+LR.length_M30+" -"+std.channel.2+"d",OBJ_TREND,0,iTime(Symbol(),period_M30,start.bar_M30),LR.price.1_M30-std.dev_M30*std.channel.2,
                                             Time[end.bar_M30],LR.price.2_M30-std.dev_M30*std.channel.2);
   ObjectSet(period_M30+"m "+LR.length_M30+" -"+std.channel.2+"d",OBJPROP_COLOR,c.2_M30);
   ObjectSet(period_M30+"m "+LR.length_M30+" -"+std.channel.2+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(period_M30+"m "+LR.length_M30+" -"+std.channel.2+"d",OBJPROP_RAY,false);
   
//...standard deviation H1

  double x_H1=0,x.sum_H1=0,x.avg_H1=0,x.sum.squared_H1=0,std.dev_H1=0,std1.dev_H1=0;
    for(i_H1=0; i_H1<start.bar_H1; i_H1++)    {
      x_H1=MathAbs(iClose(Symbol(),period_H1,i_H1)-ObjectGetValueByShift(period_H1+"m "+LR.length_H1+" TL",i_H1));
      x.sum_H1+=x_H1;
      if(i_H1>0)  {
                  
         x.avg_H1=(x.avg_H1+x_H1)/i_H1;
         x.sum.squared_H1+=(x_H1-x.avg_H1)*(x_H1-x.avg_H1);
         std.dev_H1=MathSqrt(x.sum.squared_H1/(start.bar_H1-1));
  }  }
       
   
   ObjectCreate(period_H1+"m "+LR.length_H1+" +"+std.channel.2+"d",OBJ_TREND,0,iTime(Symbol(),per,start.bar_H1),LR.price.1_H1+std.dev_H1*std.channel.2,
                                             Time[end.bar_H1],LR.price.2_H1+std.dev_H1*std.channel.2);
   ObjectSet(period_H1+"m "+LR.length_H1+" +"+std.channel.2+"d",OBJPROP_COLOR,c.2_H1);
   ObjectSet(period_H1+"m "+LR.length_H1+" +"+std.channel.2+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(period_H1+"m "+LR.length_H1+" +"+std.channel.2+"d",OBJPROP_RAY,false);
 
   ObjectCreate(period_H1+"m "+LR.length_H1+" -"+std.channel.2+"d",OBJ_TREND,0,iTime(Symbol(),period_H1,start.bar_H1),LR.price.1_H1-std.dev_H1*std.channel.2,
                                             Time[end.bar_H1],LR.price.2_H1-std.dev_H1*std.channel.2);
   ObjectSet(period_H1+"m "+LR.length_H1+" -"+std.channel.2+"d",OBJPROP_COLOR,c.2_H1);
   ObjectSet(period_H1+"m "+LR.length_H1+" -"+std.channel.2+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(period_H1+"m "+LR.length_H1+" -"+std.channel.2+"d",OBJPROP_RAY,false);

return(0);}

//+------------------------------------------------------------------+